; FUNKUHR MIT U880 / Funkamateur 4,5/1986

; Der Fehler bei der Wochentagsberechnung wurde leider nicht gefunden.
; Dieses File enthaelt daher nur einen Patch, der den Vergleich zwischen
; empfangenen und berechneten Wochentag unwirksam macht - Suche PATCH1

; Gepatched wurde: Opcode "CP B" ersetzt durch "CP A" an Adresse 02CEh
; 02CE: B8 ==> BF
; 
; Weitergabe und Modifikation dieses ASM-Quelltextes sowie des zugehoerigen
; BIN-Files an Dritte ist erlaubt, soweit keine Rechte des Autors,
; Steffen Lehmann, verletzt werden.
; Es wird keinerlei Garantie oder Gewaehrleistung fuer die Richtigkkeit der
; Fehlerkorrektur uebernommen.
;
; Wolfram Burkhardt, Berlin, Januar 2000
; EMail: wolpino@t-online.de

;*******************************************************************
; PIO-Ports
;*******************************************************************
PIO_A_DATA       EQU 07Ch
PIO_B_DATA       EQU 07Dh
PIO_A_CMD        EQU 07Eh
PIO_B_CMD        EQU 07Fh

;*******************************************************************
; CTC-Kanaele
;*******************************************************************
CTC_KAN_0        EQU 0BCh
CTC_KAN_1        EQU 0BDh
CTC_KAN_2        EQU 0BEh
CTC_KAN_3        EQU 0BFh

;*******************************************************************
; Fehlercodes - Achtung: BCD-Format (zweistellig hex)
;*******************************************************************
ERR_SEKUNDEN     EQU 001h
ERR_STARTBIT     EQU 002h
ERR_CHECK_1      EQU 003h
ERR_CHECK_2      EQU 004h
ERR_CHECK_3      EQU 005h
ERR_MINUTE       EQU 006h
ERR_STUNDE       EQU 007h
ERR_WOCHENTAG    EQU 008h
ERR_WOCHE_7      EQU 009h
ERR_WOCHE_0      EQU 010h
ERR_MONAT        EQU 011h
ERR_JAHR         EQU 012h
ERR_WT_CHECK     EQU 013h
ERR_BITWECHSEL   EQU 014h
ERR_OVERFLOW     EQU 015h
ERR_STOERUNG     EQU 016h

;*******************************************************************
; RAM-Addressen und Bedeutung (noch unvollstaendig)
; (das herauszubekommen, war Schwerstarbeit!)  ;-(
;*******************************************************************
RAM_BASE         EQU 08000h  ; Startadresse RAM
RAM_SIZE         EQU 256

;************* STACK *****************************
TOS              EQU RAM_BASE + RAM_SIZE - 1    ; Top Of Stack

;************* Ausgabe-Puffer ********************
RAM_DISP_BUFFER  EQU RAM_BASE+00Ch
RAM_DISP_ERROR   EQU RAM_DISP_BUFFER+006h ; die letzten beiden Stellen

;************* Uhrzeit (Software-Uhr) ************
RAM_SEKUNDE      EQU RAM_BASE+014h ; Hexa, 1/4 Sekunden!!
RAM_MINUTE       EQU RAM_BASE+015h ; BCD
RAM_STUNDE       EQU RAM_BASE+016h ; BCD

;************* DATUM (Software-Uhr) **************
RAM_WOCHENTAG    EQU RAM_BASE+017h ; 1...7 = Mo...So
RAM_TAG          EQU RAM_BASE+018h ; BCD
RAM_MONAT        EQU RAM_BASE+019h ; BCD
RAM_JAHR         EQU RAM_BASE+01Ah ; BCD

;************* Impulszaehler *********************
DCF_PULSE_COUNT  EQU RAM_BASE+01Bh ; 0..58 - zaehlt empf. Impulse

;************* empfangene DCF Werte*********** ***
DCF_MINUTE       EQU RAM_BASE+01Ch ; BCD, 00...59h 
DCF_STUNDE       EQU RAM_BASE+01Dh ; BCD, 00...23h
DCF_WOCHENTAG    EQU RAM_BASE+01Eh ; 1...7 = Mo...So
DCF_TAG          EQU RAM_BASE+01Fh ; BCD, 01...31h - es fehlt Test auf Null?
DCF_MONAT        EQU RAM_BASE+020h ; BCD, 01...12h - es fehlt Test auf Null?
DCF_JAHR         EQU RAM_BASE+021h ; BCD, 00...99h - 1986..1999 u. 2000..2085?

;************* Position Ausgabe-Stelle fuer NMI **
RAM_DISP_POS_NMI EQU RAM_BASE+022h ; nur Bits 0-2 relevant

;************* STATUS ****************************
IX_BASE          EQU RAM_BASE+022h ; IX-benutzte Basisregister
IX_001           EQU IX_BASE +001h
IX_002           EQU IX_BASE +002h
IX_003           EQU IX_BASE +003h
IX_004           EQU IX_BASE +004h

IX_STATUS_FLAGS  EQU IX_003 ; Status-Register
;  Bit1: 0=Uhr sucht nach erster Uhrzeit - alle Ziffern aus, Logo ausgeben
;        1=Es wurde schon einmal eine Uhrzeit empfangen - Anzeige moeglich
;  Bit2: 0=
;        1=
;  Bit3: 0=keine Stoerimpulse erkannt
;        1=Stoerimpulse detektiert (Bitwechsel)

;************* Funktionszeiger SOUND *************

;08027h - ???

FPTR_SOUND       EQU RAM_BASE+028h ; Func-Pointer Tonausgabe Stunde/Virtelst.

;************* ERROR *****************************
RAM_ERROR        EQU RAM_BASE+02Ah ; BCD

;0802Bh - PTR
;0802Dh - PTR

;************* Schieberegister *******************
; das Startbit gehoert natuerlich mit zum Schieberegister, aber so die 
; eigentlichen Werte kommen dahinter - liest sich besser
RAM_STARTBIT     EQU RAM_BASE+041h 
RAM_SHIFTREG     EQU RAM_BASE+042h

;.....

;************* Tabelle mit Anzahl der Tage *******
;************* pro Monat *************************
RAM_DAYS_PER_MONTH EQU RAM_BASE+069h
RAM_DAYS_FEBRUARY  EQU RAM_BASE+06Bh ; Monat Februar wird direkt adressiert

;************* Hilfsvariablen im Kalender ********
KAL_DCF_TAG      EQU RAM_BASE+07Ch ; Tag Binaer   (01h..1Fh)
KAL_DCF_MONAT    EQU RAM_BASE+07Dh ; Monat Binaer (01h..0Ch)
KAL_DCF_JAHR     EQU RAM_BASE+07Eh ; Jahr Binaer  (00h..63h)

KAL_TAG_MOD      EQU RAM_BASE+07Fh ; Tag normiert von 0 bis 6 (nach modulo-7)
KAL_SCHALTJ      EQU RAM_BASE+080h ; Schaltjahr-Flag: 0 oder 1, 1=Schaltjahr
;                    RAM_BASE+081h ; wird geschrieben, aber nie benutzt
KAL_TAG_OFFS     EQU RAM_BASE+082h ; Offset durch Verschiebung Tag/Monat
KAL_OFFSET2      EQU RAM_BASE+083h ; Zusaetzlicher Offset

; ******************************************************************
; RAM-Layout (noch unvollstaendig)
; ******************************************************************
; 
; 8000h: const WORD LINTVEK_1   ; Interrupt-Vektor
; 8002h: const WORD LINTVEK_2   ; Interrupt-Vektor
; 8004h: volat WORD LINTVEK_3   ; Interrupt-Vektor
; 8006h: const WORD LINTVEK_5   ; Interrupt-Vektor
; 8008h: volat WORD LINTVEK_4   ; Interrupt-Vektor
; 800Ah: const WORD LINTVEK_1   ; Interrupt-Vektor
; *******************************
; 800Ch: Stellen der acht Ausgabe- : stunde	- tag
; 800Dh: Ziffern von links nach    : stunde	- tag
; 800Eh: rechts.                   : minute	- monat
; 800Fh: Diese Speicherstellen     : minute	- monat
; 8010h: enthalten bereits den     : sekunde	- jahr
; 8011h: fertigen 7-Segment-       : sekunde	- jahr
; 8012h: Code.                     : wochentag	- error
; 8013h:                           : wochentag	- error
; *******************************
; .....
; 801Bh:       BYTE init   000h ; Impulszaehler fuer DCF-Impulse (0 bis 58)
; .....
; 08022:       ????             ; <<-- darauf zeigt IX - Display-POS bei NMI
; 8023h:       BYTE init   000h ; IX+001
; 8024h:       BYTE init   000h ; IX+002
; 8025h:       BYTE init   000h ; IX+003 <<-- Statusregister fuer Ausgabe
; 8026h:       BYTE             ; IX+004
; .....
; 8028h:       FPTR init L_NOTHING; Funktionszeiger fuer Tonausgabe
;......
; 802Ah:       BYTE             ; ERROR-Code
; 802Bh: ????? WORD init 0802Dh ; 



;===================================================================
; Im Kommentar befinden sich die Angaben zum originalen ASM-Code
; von Steffen Lehmann.
; Bedeutung:
;-------------------------------------------------------------------
;       OP-CODE                          ;  (oooo):   aaaa  ccccccc
;-------------------------------------------------------------------
; (oooo)  : (oooo)   = Offset im Code (nur bei Spruengen)
; aaaa    : urspruengliche Addresse des OP-Codes
; ccccccc : urspruenglicher Opcode an dieser Addresse
;===================================================================

;*******************************************************************
; Initialisierung
;*******************************************************************
;Set Stackpointer
        LD      SP,TOS                   ;            0000  31FF80

;Set Interrupt-Basis-Addresse (RAM: 80xxh)
        LD      A,080h                   ;            0003  3E80
        LD      I,A                      ;            0005  ED47
        IM      2                        ;            0007  ED5E

        LD      IX,IX_BASE               ;            0009  DD212280

; Kopiere ISR-Vektortabelle nach RAM 8000h, BC = 014h = 20 Byte
        LD      HL,LINT_VEKTORS          ;            000D  215200
        LD      DE,08000h                ;            0010  110080
        LD      BC,00014h                ;            0013  011400
        LDIR                             ;            0016  EDB0

; ?????
        LD      HL,0802Dh                ;            0018  212D80
        LD      (0802Bh),HL              ;            001B  222B80

; Zellen nullsetzen
        XOR     A                        ;            001E  AF
        LD      (IX_STATUS_FLAGS),A      ;            001F  322580
        LD      (DCF_PULSE_COUNT),A      ;            0022  321B80
        LD      (IX_001),A               ;            0025  322380
        LD      (IX_002),A               ;            0028  322480
        LD      (IX+004h),010h           ;            002B  DD360410

; ?????
        LD      A,0BBh                   ;            002F  3EBB
        LD      (RAM_ERROR),A            ;            0031  322A80

; Ausgabe Port #7E: 5 Bytes: 08-cf-80-b7-7f
        LD      HL,INIT_PIO_A            ;            0034  21DF01
        LD      BC,0057Eh                ;            0037  017E05
        OTIR                             ;            003A  EDB3

; Ausgabe Port #7F: 3 Bytes: 0a-cf-40
        LD      HL,INIT_PIO_B            ;            003C  21E401
        LD      BC,0037Fh                ;            003F  017F03
        OTIR                             ;            0042  EDB3

; Ausgabe Port #BC: 3 Bytes: 00-27-60
; HL steht bereits richtig auf INIT_CTC_0
        LD      BC,003BCh                ;            0044  01BC03
        OTIR                             ;            0047  EDB3

; Funktionszeiger setzen, steht auf RET
        LD      HL,L_NOTHING             ;            0049  21E704
        LD      (FPTR_SOUND),HL          ;            004C  222880

        EI                               ;            004F  FB
        JR      LSTART                   ;  (  80):   0050  1850


;*******************************************************************
; Platz fuer Tabelle der Interrupt-Vektoren
; Der Assembler ist so nett und traegt fuer die Platzhalter die
; Adressen der jeweiligen Routinen ein.
LINT_VEKTORS:
;*******************************************************************
        DW LINTVEK_1
        DW LINTVEK_2
        DW LINTVEK_3
        DW LINTVEK_5
        DW LINTVEK_4
        DW LINTVEK_1

DCF77_LOGO:
; Hinweis: 7-Segment-Kodierung der Buchstaben und Ziffern.
; Bei der '7' passt es zufaellig!
;           'D'   'C'   'F'   '-'   '7'   '7'   ' '   ' '
        DB 05Eh, 058h, 071h, 040h, 007h, 007h, 000h, 000h

;*******************************************************************
; NMI-Routine: Display-Ansteuerung (800 Hz)
;*******************************************************************
L0066:  EXX                              ;            0066  D9
        EX      AF,AF'                   ;            0067  08

; Nachste Ausgabe-Stelle berechnen
        LD      A,(RAM_DISP_POS_NMI)     ;            0068  3A2280
        INC     A                        ;            006B  3C
        AND     007h                     ;            006C  E607
        LD      (RAM_DISP_POS_NMI),A     ;            006E  322280

; Zeiger auf RAM und Ziffer holen
        LD      E,A                      ;            0071  5F
        LD      D,000h                   ;            0072  1600

; Startadresse im RAM fuer Display-Ausgabe laden
        LD      HL,RAM_DISP_BUFFER       ;            0074  210C80
        ADD     HL,DE                    ;            0077  19

; Berechnung der CS-Leitung und Position der Ziffern (?)
        LD      C,PIO_A_DATA             ;            0078  0E7C
        LD      A,(IX_004)               ;            007A  3A2680
        BIT     7,(IX+003h)              ;            007D  DDCB037E
        JR      Z,L0093                  ;  (  16):   0081  2810

        LD      B,A                      ;            0083  47
        LD      A,E                      ;            0084  7B
        RLCA                             ;            0085  07
        RLCA                             ;            0086  07
        RLCA                             ;            0087  07
        RLCA                             ;            0088  07
        BIT     6,(IX+003h)              ;            0089  DDCB0376
        JR      NZ,L0090                 ;  (   1):   008D  2001

        RLCA                             ;            008F  07

L0090:  AND     020h                     ;            0090  E620
        OR      B                        ;            0092  B0

L0093:  OR      E                        ;            0093  B3
        LD      E,A                      ;            0094  5F

; Out (PIO_A_DATA): Alle Segmente dunkeltasten
        XOR     A                        ;            0095  AF
        OUT     (C),A                    ;            0096  ED79

; Out (PIO_B_DATA): 1-aus-8-Dekoder auswaehlen, Ziffernposition
        LD      A,E                      ;            0098  7B
        OUT     (PIO_B_DATA),A           ;            0099  D37D

; OUT (PIO_A_DATA),(HL): Ausgabe der Ziffer aus dem RAM
        OUTI                             ;            009B  EDA3

        EXX                              ;            009D  D9
        EX      AF,AF'                   ;            009E  08
        EI                               ;            009F  FB
        RETN                             ;            00A0  ED45
; Ende NMI-Routine


;*******************************************************************
; Hautschleife
LSTART:
;*******************************************************************

; Ausgabe Fehlercode - wenn noch keine Uhrzeit bekannt ist
        BIT     1,(IX+003h)              ;            00A2  DDCB034E
        JP      Z,LRAM_DISP_ERROR        ;            00A6  CA0D01

; Startadresse im RAM fuer Display-Ausgabe laden (erste Stelle von links)
        LD      HL,RAM_DISP_BUFFER       ;            00A9  210C80

; Taste abfragen (Polling der PIO)
        IN      A,(PIO_B_DATA)           ;            00AC  DB7D
        BIT     6,A                      ;            00AE  CB77

; Taste ist gedrueckt
        JR      Z,KEY_HANDLER            ;  (  61):   00B0  283D

; Taste nicht gedrueckt - hier weiter
; aktuelle Uhrzeit ausgeben
        LD      A,(RAM_STUNDE)           ;            00B2  3A1680
        SET     2,(IX+003h)              ;            00B5  DDCB03D6
        CALL    PRINT_BCD                ;            00B9  CDBF04

        LD      A,(RAM_MINUTE)           ;            00BC  3A1580
        CALL    PRINT_BCD                ;            00BF  CDBF04

        LD      A,(RAM_SEKUNDE)          ;            00C2  3A1480
        SRL     A                        ;            00C5  CB3F
        SRL     A                        ;            00C7  CB3F
        JR      Z,L00D2                  ;  (   7):   00C9  2807

; Umrechnung Hex->BCD fuer Sekundenausgabe
        LD      B,A                      ;            00CB  47
        XOR     A                        ;            00CC  AF
L00CD:  ADD     A,001h                   ;            00CD  C601
        DAA                              ;            00CF  27
        DJNZ    L00CD                    ;  (  -5):   00D0  10FB

L00D2:  CALL    PRINT_BCD                ;            00D2  CDBF04

; Wochentagsausgabe
        LD      A,(RAM_WOCHENTAG)        ;            00D5  3A1780
        AND     007h                     ;            00D8  E607
        PUSH    HL                       ;            00DA  E5
        LD      B,A                      ;            00DB  47
        LD      HL,DATA_WEEKDAY_TO_7SEG  ;            00DC  21F304
        JR      Z,L00E7                  ;  (   6):   00DF  2806

        LD      DE,00002h                ;            00E1  110200

L00E4:  ADD     HL,DE                    ;            00E4  19
        DJNZ    L00E4                    ;  (  -3):   00E5  10FD

L00E7:  POP     DE                       ;            00E7  D1
        LD      BC,00002h                ;            00E8  010200
        LDIR                             ;            00EB  EDB0

        JR      LSTART                   ;  ( -77):   00ED  18B3

;*******************************************************************
; Behandelt gedrueckte Datumstaste - Ausgabe Datum
KEY_HANDLER:
;*******************************************************************
        LD      A,(RAM_TAG)              ;            00EF  3A1880
        SET     2,(IX+003h)              ;            00F2  DDCB03D6
        CALL    PRINT_BCD                ;            00F6  CDBF04

        LD      A,(RAM_MONAT)            ;            00F9  3A1980
        CALL    PRINT_BCD                ;            00FC  CDBF04

        LD      A,(RAM_JAHR)             ;            00FF  3A1A80
        CALL    PRINT_BCD                ;            0102  CDBF04

        LD      A,(RAM_ERROR)            ;            0105  3A2A80
        CALL    PRINT_BCD                ;            0108  CDBF04

        JR      LSTART                   ;  (-107):   010B  1895

;*******************************************************************
; Fehlercode direkt in Ausgabebuffer schreiben
; Eingabe: A=Fehlercode im 7-Segment-Format
LRAM_DISP_ERROR:
;*******************************************************************
        LD      HL,RAM_DISP_ERROR        ;            010D  211280
        LD      A,(RAM_ERROR)            ;            0110  3A2A80
        CALL    PRINT_BCD                ;            0113  CDBF04

        JR      LSTART                   ;  (-118):   0116  188A

; ENDE Idle-Routine


;*******************************************************************
; Funktion: Berechnet Summe im Speicher
; Eingabe: HL=Startadresse im Speicher
;          B =Anzahl Byte, ueber die summiert wird (mit Pruefbit!)
; Ausgabe: A = SUMME
;          Z = (A=0)
;*******************************************************************
CHECK_SUM:
        XOR     A                        ;            0118  AF

L0119:  ADD     A,(HL)                   ;            0119  86
        INC     HL                       ;            011A  23
        DJNZ    L0119                    ;  (  -4):   011B  10FC

; Akku ungerade/gerade --> landet im Z-Flag
        AND     001h                     ;            011D  E601
        RET                              ;            011F  C9


;*******************************************************************
; Funktion HOLE_EINER: Sammelt aus einer Bytefolge im Speicher die
;                    0-ten Bit' ein und packt diese entsprechend der
;                    Bypeposition in den Akku
; Eingabe: HL=Startadresse im Speicher
;          B =Anzahl Byte (sollten 8 sein (?) )
; Ausgabe: A = in einem Byte zusammengefasste Bits
;*******************************************************************
HOLE_EINER:
        XOR     A                        ;            0120  AF
        LD      E,001h                   ;            0121  1E01

; Bits vom Bit0 zusammensammeln
L0123:  BIT     0,(HL)                   ;            0123  CB46
        JR      Z,L0128                  ;  (   1):   0125  2801

        OR      E                        ;            0127  B3

L0128:  INC     HL                       ;            0128  23
        RL      E                        ;            0129  CB13
        DJNZ    L0123                    ;  ( -10):   012B  10F6

        RET                              ;            012D  C9

;*******************************************************************
; INTERRUPT-Routine: Aufruf bei jeden DCF-Impuls
;*******************************************************************
LINTVEK_4:
        PUSH    AF                       ;            012E  F5
        PUSH    HL                       ;            012F  E5
        LD      A,003h                   ;            0130  3E03
        OUT     (CTC_KAN_1),A            ;            0132  D3BD

        LD      HL,L01D8                 ;            0134  21D801
        LD      (08008h),HL              ;            0137  220880
        LD      A,0D7h                   ;            013A  3ED7
        OUT     (CTC_KAN_2),A            ;            013C  D3BE

        LD      A,00Ch                   ;            013E  3E0C
        OUT     (CTC_KAN_2),A            ;            0140  D3BE

        LD      HL,LINTVEK_3             ;            0142  215601
        LD      (08004h),HL              ;            0145  220480

; DCF-Impulse mitzaehlen
        LD      A,(DCF_PULSE_COUNT)      ;            0148  3A1B80
        ADD     A,001h                   ;            014B  C601
        DAA                              ;            014D  27
        LD      (DCF_PULSE_COUNT),A      ;            014E  321B80

        POP     HL                       ;            0151  E1
        POP     AF                       ;            0152  F1
        EI                               ;            0153  FB
        RETI                             ;            0154  ED4D

;*******************************************************************
; INTERRUPT-Routine: PIO-A
;*******************************************************************
LINTVEK_3:
        PUSH    AF                       ;            0156  F5
        PUSH    HL                       ;            0157  E5
        LD      HL,(0802Bh)              ;            0158  2A2B80
        IN      A,(PIO_A_DATA)           ;            015B  DB7C

        AND     080h                     ;            015D  E680
        LD      (HL),A                   ;            015F  77
        LD      A,0D7h                   ;            0160  3ED7
        OUT     (CTC_KAN_2),A            ;            0162  D3BE

        LD      A,003h                   ;            0164  3E03
        OUT     (CTC_KAN_2),A            ;            0166  D3BE

        LD      HL,L0173                 ;            0168  217301

L016B:  LD      (08004h),HL              ;            016B  220480
        POP     HL                       ;            016E  E1
        POP     AF                       ;            016F  F1
        EI                               ;            0170  FB
        RETI                             ;            0171  ED4D

;*******************************************************************
; INTERRUPT-Routine: PIO-A
;*******************************************************************
L0173:
        PUSH    AF                       ;            0173  F5
        PUSH    HL                       ;            0174  E5
        LD      HL,(0802Bh)              ;            0175  2A2B80
        IN      A,(PIO_A_DATA)           ;            0178  DB7C

        AND     080h                     ;            017A  E680
        CP      (HL)                     ;            017C  BE
        CALL    NZ,L01CE                 ;            017D  C4CE01

        LD      A,0D7h                   ;            0180  3ED7
        OUT     (CTC_KAN_1),A            ;            0182  D3BD

        LD      A,064h                   ;            0184  3E64
        OUT     (CTC_KAN_1),A            ;            0186  D3BD

        LD      HL,L018D                 ;            0188  218D01
        JR      L016B                    ;  ( -34):   018B  18DE

;*******************************************************************
; INTERRUPT-Routine: PIO-A / CTC
;*******************************************************************
L018D:
        PUSH    AF                       ;            018D  F5
        PUSH    HL                       ;            018E  E5
        LD      HL,(0802Bh)              ;            018F  2A2B80
        IN      A,(PIO_A_DATA)           ;            0192  DB7C

        AND     080h                     ;            0194  E680
        CP      (HL)                     ;            0196  BE
        CALL    NZ,L01CE                 ;            0197  C4CE01

        RLCA                             ;            019A  07
        AND     001h                     ;            019B  E601
        LD      (HL),A                   ;            019D  77
        INC     HL                       ;            019E  23
        LD      (0802Bh),HL              ;            019F  222B80
        LD      A,069h                   ;            01A2  3E69
        CP      L                        ;            01A4  BD
        JR      NZ,L01B0                 ;  (   9):   01A5  2009

        DEC     HL                       ;            01A7  2B
        LD      (0802Bh),HL              ;            01A8  222B80
        LD      A,015h                   ;            01AB  3E15
        CALL    L01D0                    ;            01AD  CDD001

L01B0:  LD      A,0D7h                   ;            01B0  3ED7
        OUT     (CTC_KAN_2),A            ;            01B2  D3BE
        LD      A,050h                   ;            01B4  3E50
        OUT     (CTC_KAN_2),A            ;            01B6  D3BE
        LD      HL,L01BD                 ;            01B8  21BD01
        JR      L016B                    ;  ( -82):   01BB  18AE

;*******************************************************************
; INTERRUPT-Routine:
;*******************************************************************
L01BD:
        PUSH    AF                       ;            01BD  F5
        PUSH    HL                       ;            01BE  E5
        LD      A,003h                   ;            01BF  3E03
        OUT     (CTC_KAN_2),A            ;            01C1  D3BE

        LD      HL,LINTVEK_4             ;            01C3  212E01
        LD      (08008h),HL              ;            01C6  220880
        POP     HL                       ;            01C9  E1
        POP     AF                       ;            01CA  F1
        EI                               ;            01CB  FB
        RETI                             ;            01CC  ED4D


;*******************************************************************
; Funktion:
;*******************************************************************
L01CE:  LD      A,014h                   ;            01CE  3E14

L01D0:  LD      (RAM_ERROR),A            ;            01D0  322A80
        SET     3,(IX+003h)              ;            01D3  DDCB03DE
        RET                              ;            01D7  C9

;*******************************************************************
; INTERRUPT-Routine:
;*******************************************************************
L01D8:
        SET     3,(IX+003h)              ;            01D8  DDCB03DE

;*******************************************************************
; INTERRUPT-Routine (Vektor)
;*******************************************************************
LINTVEK_1:
        EI                               ;            01DC  FB
        RETI                             ;            01DD  ED4D

;*******************************************************************
; DATA - PIO und CTC-Initialisierung
;*******************************************************************
INIT_PIO_A:      ; PIO Kanal A
        DB 008h
        DB 0CFh
        DB 080h
        DB 0B7h
        DB 07Fh

INIT_PIO_B:      ; PIO Kanal B
        DB 00Ah
        DB 0CFh
        DB 040h

INIT_CTC_0:      ; CTC kanal 0
        DB 000h
        DB 027h
        DB 060h

;*******************************************************************
; INTERRUPT-Routine (Vektor) - CTC-Routine
; Sammelt die Bits des Schieberegisters zusammen und legt diese
; byteweise im Speicher ab
;*******************************************************************
LINTVEK_2:
        PUSH    AF                       ;            01EA  F5
        PUSH    BC                       ;            01EB  C5
        PUSH    DE                       ;            01EC  D5
        PUSH    HL                       ;            01ED  E5

; Bereite Eintritt beim naechsten INT vor 
        LD      HL,L01D8                 ;            01EE  21D801
        LD      (08008h),HL              ;            01F1  220880

        LD      A,0D7h                   ;            01F4  3ED7
        OUT     (CTC_KAN_2),A            ;            01F6  D3BE
        LD      A,053h                   ;            01F8  3E53
        OUT     (CTC_KAN_2),A            ;            01FA  D3BE

        LD      HL,L0304                 ;            01FC  210403
        LD      (08004h),HL              ;            01FF  220480

        LD      A,003h                   ;            0202  3E03
        OUT     (CTC_KAN_1),A            ;            0204  D3BD

; Test auf Stoerung des Impulserkenners
; (Bitwechsel innerhalb CTC-Takt der Software-Uhr)
        BIT     3,(IX+003h)              ;            0206  DDCB035E
        RES     3,(IX+003h)              ;            020A  DDCB039E
        LD      B,ERR_STOERUNG           ;            020E  0616
        JP      NZ,PRINT_ERROR           ;            0210  C2DB02

; Test, ob 58 Impulse empfangen wurden - (es fehlte JETZT der Sekunden-
; implus, was Ende der Minute bedeutet)
        LD      A,(DCF_PULSE_COUNT)      ;            0213  3A1B80
        CP      058h                     ;            0216  FE58
        LD      B,ERR_SEKUNDEN           ;            0218  0601
        JP      NZ,PRINT_ERROR           ;            021A  C2DB02

; Test auf Startbit - muss 1 sein
        LD      A,(RAM_STARTBIT)         ;            021D  3A4180
        OR      A                        ;            0220  B7
        LD      B,ERR_STARTBIT           ;            0221  0602
        JP      Z,PRINT_ERROR            ;            0223  CADB02

; HL auf Schieberegisteranfang setzen
        LD      HL,RAM_SHIFTREG          ;            0226  214280

; erste acht Bits sammeln - Pruefsumme fuer Minuten berechnen
; (Summe einschliesslich Pruefbit #1)
        LD      B,008h                   ;            0229  0608
        CALL    CHECK_SUM                ;            022B  CD1801

        LD      B,ERR_CHECK_1            ;            022E  0603
        JP      NZ,PRINT_ERROR           ;            0230  C2DB02

; naechste sieben Bits sammeln - Pruefsumme fuer Stunden berechnen
; (Summe einschliesslich Pruefbit #2)
        LD      B,007h                   ;            0233  0607
        CALL    CHECK_SUM                ;            0235  CD1801

        LD      B,ERR_CHECK_2            ;            0238  0604
        JP      NZ,PRINT_ERROR           ;            023A  C2DB02

; naechste 23 Bits sammeln - Pruefsumme fuer alles, was mit Datum zu tun hat
; (Summe einschliesslich Pruefbit #3)
        LD      B,017h                   ;            023D  0617
        CALL    CHECK_SUM                ;            023F  CD1801

        LD      B,ERR_CHECK_3            ;            0242  0605
        JP      NZ,PRINT_ERROR           ;            0244  C2DB02

; HL wieder auf den Anfang des Schieberegisters setzen
        LD      HL,RAM_SHIFTREG          ;            0247  214280

; 4 Bit "Minute-Einer" holen
        LD      B,004h                   ;            024A  0604
        CALL    HOLE_EINER               ;            024C  CD2001

; 3 Bit Minute Zehner holen, Einer addieren, testen
; BC: B=003h (3 Bit holen), C=060h: erlaubter Maximalwert+1
        LD      D,A                      ;            024F  57
        LD      BC,00360h                ;            0250  016003
        CALL    HOLE_ZEHNER              ;            0253  CDFA02

        LD      B,ERR_MINUTE             ;            0256  0606
        JP      NC,PRINT_ERROR           ;            0258  D2DB02

; Minute ablegen
        LD      (DCF_MINUTE),A           ;            025B  321C80

; Pruefbit #1 ueberspringen
        INC     HL                       ;            025E  23

; 4 Bit "Stunde-Einer" holen
        LD      B,004h                   ;            025F  0604
        CALL    HOLE_EINER               ;            0261  CD2001

; 2 Bit Stunde Zehner holen, Einer addieren, testen
; BC: B=002h (2 Bit holen), C=024h: erlaubter Maximalwert+1
        LD      D,A                      ;            0264  57
        LD      BC,00224h                ;            0265  012402
        CALL    HOLE_ZEHNER              ;            0268  CDFA02

        LD      B,ERR_STUNDE             ;            026B  0607
        JR      NC,PRINT_ERROR           ;  ( 108):   026D  306C

; Stunde ablegen
        LD      (DCF_STUNDE),A           ;            026F  321D80

; Pruefbit #2 ueberspringen
        INC     HL                       ;            0272  23

; 4 Bit "Kalendertag" holen
        LD      B,004h                   ;            0273  0604
        CALL    HOLE_EINER               ;            0275  CD2001
 
; 2 Bit Stunde Zehner holen, Einer addieren, testen
; BC: B=002h (2 Bit holen), C=032h: erlaubter Maximalwert+1
        LD      D,A                      ;            0278  57
        LD      BC,00232h                ;            0279  013202
        CALL    HOLE_ZEHNER              ;            027C  CDFA02

        LD      B,ERR_WOCHENTAG          ;            027F  0608
        JR      NC,PRINT_ERROR           ;  (  88):   0281  3058

; Kalendertag ablegen
; Hier fehlt eigentlich der Test auf Null (??)
        LD      (DCF_TAG),A              ;            0283  321F80

; 3 Bit "Wochentag" holen
        LD      B,003h                   ;            0286  0603
        CALL    HOLE_EINER               ;            0288  CD2001

; der folgende Test auf groeser 7 ist eigentlich ueberfluessig, da das nie
; passieren kann (3 Bit koennen nie mehr als 7 ergeben)
        LD      D,A                      ;            028B  57
        AND     0F8h                     ;            028C  E6F8
        LD      B,ERR_WOCHE_7            ;            028E  0609
        JR      NZ,PRINT_ERROR           ;  (  73):   0290  2049

; Test auf Null (hier wird einer gemacht!)
        LD      A,D                      ;            0292  7A
        OR      A                        ;            0293  B7
        LD      B,ERR_WOCHE_0            ;            0294  0610
        JR      Z,PRINT_ERROR            ;  (  67):   0296  2843

; Wochentag ablegen
        LD      (DCF_WOCHENTAG),A        ;            0298  321E80

; 4 Bit "Monat" holen
        LD      B,004h                   ;            029B  0604
        CALL    HOLE_EINER               ;            029D  CD2001

; 1 Bit Monat Zehner holen, Einer addieren, testen
; BC: B=001h (1 Bit holen), C=013h: erlaubter Maximalwert+1
        LD      D,A                      ;            02A0  57
        LD      BC,00113h                ;            02A1  011301
        CALL    HOLE_ZEHNER              ;            02A4  CDFA02

        LD      B,ERR_MONAT              ;            02A7  0611
        JR      NC,PRINT_ERROR           ;  (  48):   02A9  3030

; Monat ablegen
; Hier fehlt eigentlich auch der Test auf Null (??)
        LD      (DCF_MONAT),A            ;            02AB  322080

; 4 Bit "Jahr" holen
        LD      B,004h                   ;            02AE  0604
        CALL    HOLE_EINER               ;            02B0  CD2001

; 4 Bit Jahr Zehner holen, Einer addieren, testen
; BC: B=004h (4 Bit holen), C=09Ah: erlaubter Maximalwert+1
; Maximalwert ist dezimal 99d --> BCD 099h --> 099h+1 --> 09Ah
        LD      D,A                      ;            02B3  57
        LD      BC,0049Ah                ;            02B4  019A04
        CALL    HOLE_ZEHNER              ;            02B7  CDFA02

        LD      B,ERR_JAHR               ;            02BA  0612
        JR      NC,PRINT_ERROR           ;  (  29):   02BC  301D

; Jahr ablegen
        LD      (DCF_JAHR),A             ;            02BE  322180

; Achtung: das Jahr ist "echt" zweistellig unabhaengig vom Jahrhundert!
; Das Jahrhundert sollte der, der die Uhr abliest, schon selbst wissen -
; allerdings hat der Kalender (siehe unten) ein Problem damit.
; Es ist fuer den Kalender eine Vereinbarung notwendig:
; Sinnvoll ist z.B.: xx von 80 bis 99: ==> 19xx
;                    xx von 00 bis 79: ==> 20xx
; Es konnte bisher nicht ermittelt werden, wo beim benutzten Kalender
; die Grenze liegt :-(

; Kalender aufrufen, berechnet aus dem empfangenen Datum den Wochentag
        LD      HL,(DCF_MONAT)           ;            02C1  2A2080
        LD      A,(DCF_TAG)              ;            02C4  3A1F80
        CALL    KALENDER                 ;            02C7  CD1605

        LD      B,A                      ;            02CA  47
        LD      A,(DCF_WOCHENTAG)        ;            02CB  3A1E80

; Vergleich errechneter Wochentag - empfangener Wochentag

;BEGINN PATCH1
; Macht den Test unwirksam.
; CP A setzt immer das Zero-Flag
;       CP      B                        ;            02CE  B8
        CP      A
;ENDE PATCH1

        LD      B,013h                   ;            02CF  0613
        JR      NZ,PRINT_ERROR           ;  (   8):   02D1  2008

        LD      A,003h                   ;            02D3  3E03
        OUT     (CTC_KAN_3),A            ;            02D5  D3BF
        LD      A,0BBh                   ;            02D7  3EBB
        JR      L02EA                    ;  (  15):   02D9  180F

PRINT_ERROR:
        LD      A,003h                   ;            02DB  3E03
        OUT     (CTC_KAN_2),A            ;            02DD  D3BE
        LD      (IX+004h),010h           ;            02DF  DD360410
        LD      HL,LINTVEK_4             ;            02E3  212E01
        LD      (08008h),HL              ;            02E6  220880
        LD      A,B                      ;            02E9  78

L02EA:  LD      (RAM_ERROR),A            ;            02EA  322A80
        LD      (IX-007h),099h           ;            02ED  DD36F999

; wichtig!
        LD      HL,0802Dh                ;            02F1  212D80
        LD      (0802Bh),HL              ;            02F4  222B80

; **ENDE**
; Springt ans Ende einer anderen ISR - dort steht zufaellig das was wir hier
; brauchen (Register poppen, ....)
        JP      L047A                    ;            02F7  C37A04



;*******************************************************************
; Funktion: Holt Zehnerstelle aus dem Schieberegister und addiert
;           Einer dazu. Ergebnis: BCD-Kodiert!
; Eingabe:  HL = Addresse im Speicher (Schieberegister)
;           B  = Anzahl Bits im Zehner
;           C  = erlaubter Maximalwert
;           D  = bereits vorher gelesener Wert des Einers
; Ausgabe:  A  = 2-stelliger BCD-Wert
;           Z,C,S, ... Flags
;*******************************************************************
HOLE_ZEHNER:
        CALL    HOLE_EINER              ;            02FA  CD2001

; Zehner auf hoeherwertiges Halbbyte schieben
        RLCA                             ;            02FD  07
        RLCA                             ;            02FE  07
        RLCA                             ;            02FF  07
        RLCA                             ;            0300  07
; "Addiere" D zu A (Einer), erspart DAA
        OR      D                        ;            0301  B2
        CP      C                        ;            0302  B9
        RET                              ;            0303  C9

;*******************************************************************
; INTERRUPT-Routine:
;*******************************************************************
L0304:  PUSH    AF                       ;            0304  F5
        PUSH    BC                       ;            0305  C5
        PUSH    DE                       ;            0306  D5
        PUSH    HL                       ;            0307  E5
        LD      HL,L030F                 ;            0308  210F03
        PUSH    HL                       ;            030B  E5
        EI                               ;            030C  FB
        RETI                             ;            030D  ED4D

;*******************************************************************
; Funktion:
;*******************************************************************
L030F:  LD      HL,LINTVEK_4             ;            030F  212E01
        LD      (08008h),HL              ;            0312  220880
        LD      A,003h                   ;            0315  3E03
        OUT     (CTC_KAN_2),A            ;            0317  D3BE
        LD      HL,INIT_CTC_0            ;            0319  21E701
        LD      BC,003BCh                ;            031C  01BC03
        OTIR                             ;            031F  EDB3

        LD      A,0D7h                   ;            0321  3ED7
        OUT     (CTC_KAN_3),A            ;            0323  D3BF
        LD      A,019h                   ;            0325  3E19
        OUT     (CTC_KAN_3),A            ;            0327  D3BF
        LD      HL,DCF_MINUTE            ;            0329  211C80
        LD      DE,RAM_MINUTE            ;            032C  111580
        LD      BC,00006h                ;            032F  010600
        LDIR                             ;            0332  EDB0

        LD      (IX-00Eh),B              ;            0334  DD70F2
        LD      (IX+004h),090h           ;            0337  DD360490
        SET     1,(IX+003h)              ;            033B  DDCB03CE
        DI                               ;            033F  F3
        BIT     4,(IX+003h)              ;            0340  DDCB0366
        JR      NZ,L034D                 ;  (   7):   0344  2007

        CALL    L0353                    ;            0346  CD5303

        SET     4,(IX+003h)              ;            0349  DDCB03E6

L034D:  EI                               ;            034D  FB
        POP     HL                       ;            034E  E1
        POP     DE                       ;            034F  D1
        POP     BC                       ;            0350  C1
        POP     AF                       ;            0351  F1
        RET                              ;            0352  C9


;*******************************************************************
; Funktion: Testet auf Viertelstunde zur Ausgabe der Piepstoene
;*******************************************************************
L0353:  LD      HL,IX_001 ;      IX+001h ;            0353  212380
        LD      A,(RAM_MINUTE)           ;            0356  3A1580
        CP      015h                     ;            0359  FE15
        CALL    Z,L0393                  ;            035B  CC9303

        CP      030h                     ;            035E  FE30
        CALL    Z,L0392                  ;            0360  CC9203

        CP      045h                     ;            0363  FE45
        CALL    Z,L0391                  ;            0365  CC9103

        OR      A                        ;            0368  B7
        RET     NZ                       ;            0369  C0

;*******************************************************************
; Funktion: Stundenschlag berechnen (Piepstoene)
;*******************************************************************
        LD      A,(RAM_STUNDE)           ;            036A  3A1680
        CP      013h                     ;            036D  FE13
        JR      C,L0374                  ;  (   3):   036F  3803

        SUB     012h                     ;            0371  D612
        DAA                              ;            0373  27

L0374:  CP      010h                     ;            0374  FE10
        JR      C,L037A                  ;  (   2):   0376  3802

        SUB     006h                     ;            0378  D606

L037A:  OR      A                        ;            037A  B7
        JR      NZ,L037F                 ;  (   2):   037B  2002

        LD      A,00Ch                   ;            037D  3E0C

L037F:  LD      (IX_002),A               ;            037F  322480
        SLA     (IX+002h)                ;            0382  DDCB0226
        SLA     (IX+002h)                ;            0386  DDCB0226
        LD      HL,L049F                 ;            038A  219F04
        LD      (FPTR_SOUND),HL          ;            038D  222880
        RET                              ;            0390  C9

;*******************************************************************
; Funktion: Stundenschlag
;*******************************************************************
L0391:  INC     (HL)                     ;            0391  34

L0392:  INC     (HL)                     ;            0392  34

L0393:  INC     (HL)                     ;            0393  34
        SET     7,(IX+003h)              ;            0394  DDCB03FE
        LD      HL,L0486                 ;            0398  218604
        LD      (FPTR_SOUND),HL          ;            039B  222880
        RET                              ;            039E  C9

;*******************************************************************
; INTERRUPT-Routine (Vektor) - CTC Interrupt - Software-Uhr
;*******************************************************************
LINTVEK_5:
        PUSH    AF                       ;            039F  F5
        PUSH    BC                       ;            03A0  C5
        PUSH    DE                       ;            03A1  D5
        PUSH    HL                       ;            03A2  E5
        LD      HL,L03AB                 ;            03A3  21AB03
        PUSH    HL                       ;            03A6  E5
        LD      HL,(FPTR_SOUND)          ;            03A7  2A2880
        JP      (HL)                     ;            03AA  E9


L03AB:
        ; Sekunden hochzaehlen
        ; Sekunden werden als echte "Ticks" im 8bit-binaer-Format
        ; gezaehlt, alles andere (Minuten, Stunden etc.) dagegen BCD!
        LD      A,(RAM_SEKUNDE)          ;            03AB  3A1480
        INC     A                        ;            03AE  3C
        LD      (RAM_SEKUNDE),A          ;            03AF  321480

        ; nach 30 Sekunden...
        CP      078h                     ;            03B2  FE78
        CALL    Z,L0481                  ;            03B4  CC8104

        ; der Interrupt kommt 4 mal pro Sekunde -> 240 "Ticks"
        CP      0F0h                     ;            03B7  FEF0

        ; es ist noch keine Minute vorbei - 'raus
        JP      C,L047A                  ;            03B9  DA7A04

        XOR     A                        ;            03BC  AF
        LD      (RAM_SEKUNDE),A          ;            03BD  321480
        BIT     1,(IX+003h)              ;            03C0  DDCB034E
        JR      Z,L03CA                  ;  (   4):   03C4  2804

        LD      (IX+004h),010h           ;            03C6  DD360410

L03CA:
        ; Minuten hochzaehlen
        LD      A,(RAM_MINUTE)           ;            03CA  3A1580
        ADD     A,001h                   ;            03CD  C601
        DAA                              ;            03CF  27
        LD      (RAM_MINUTE),A           ;            03D0  321580
        PUSH    AF                       ;            03D3  F5
        BIT     4,(IX+003h)              ;            03D4  DDCB0366
        CALL    Z,L0353                  ;            03D8  CC5303

        POP     AF                       ;            03DB  F1
        CP      060h ; 60 BCD!           ;            03DC  FE60

        ; es ist noch keine Stunde vorbei - 'raus
        JP      C,L047A                  ;            03DE  DA7A04

        XOR     A                        ;            03E1  AF
        LD      (RAM_MINUTE),A           ;            03E2  321580

        ; Stunden hochzaehlen
        LD      A,(RAM_STUNDE)           ;            03E5  3A1680
        ADD     A,001h                   ;            03E8  C601
        DAA                              ;            03EA  27
        LD      (RAM_STUNDE),A           ;            03EB  321680
        PUSH    AF                       ;            03EE  F5
        BIT     4,(IX+003h)              ;            03EF  DDCB0366
        CALL    Z,L0353                  ;            03F3  CC5303

        POP     AF                       ;            03F6  F1

        ; es ist noch kein ganzer Tag vorbei - 'raus
        CP      024h ; 24 BCD!           ;            03F7  FE24

        ; noch kein Uebertrag - 'raus
        JR      C,L047A                  ;  ( 127):   03F9  387F

        XOR     A                        ;            03FB  AF
        LD      (RAM_STUNDE),A           ;            03FC  321680
        BIT     4,(IX+003h)              ;            03FF  DDCB0366
        CALL    Z,L0353                  ;            0403  CC5303

        ; naechster Wochentag - 1...7
        ; es ist noch kein ganzer Tag vorbei - 'raus
        LD      A,(RAM_WOCHENTAG)        ;            0406  3A1780
        INC     A                        ;            0409  3C
        AND     007h                     ;            040A  E607
        JR      NZ,L040F                 ;  (   1):   040C  2001

        INC     A                        ;            040E  3C

L040F:  LD      (RAM_WOCHENTAG),A        ;            040F  321780

        ; Berechnung der Tabelle mit Anzahl der Tage pro Monat
        ; Jetzt wird's recht kompliziert - und etwas umstaendlich.

        ; Das mit der RAM-Kopie haette man auch vereinfachen
        ; koennen, indem man stets die Anzahl der Tage aus der
        ; Tabelle im EPROM nimmt und in ein CPU-Register laedt und
        ; nur im Falle eines Schaltjahres (Jahr AND 003h == 0) das
        ; Register inkrementiert. 
        ; Die vorhandene Prozedur aendert dagegen in der RAM-Kopie.

        ; Daten aus dem EPROM
        LD      HL,DATA_DAYS_PER_MONTH   ;            0412  210305

        ; Da die Kopie im RAM anlegen
        LD      DE,RAM_DAYS_PER_MONTH    ;            0415  116980

        ; 19 Byte kopieren (12 Monate + 6 Byte Luecke wegen Hex<->BCD
        ;                   + erstes Byte = Dummy)
        LD      BC,00013h                ;            0418  011300
        LDIR                             ;            041B  EDB0

        ; Ermitteln ob es ein Schaltjahr ist (VIEL zu kompliziert...)
        LD      A,(RAM_JAHR)             ;            041D  3A1A80
        RRCA                             ;            0420  0F
        RRCA                             ;            0421  0F
        RRCA                             ;            0422  0F
        RRCA                             ;            0423  0F
        LD      C,000h                   ;            0424  0E00
        AND     00Fh                     ;            0426  E60F
        LD      B,A                      ;            0428  47
        JR      Z,L0430                  ;  (   5):   0429  2805

        ; BCD->BIN
        XOR     A                        ;            042B  AF

L042C:  ADD     A,00Ah                   ;            042C  C60A
        DJNZ    L042C                    ;  (  -4):   042E  10FC

L0430:  PUSH    AF                       ;            0430  F5
        LD      A,(RAM_JAHR)             ;            0431  3A1A80
        AND     00Fh                     ;            0434  E60F
        LD      B,A                      ;            0436  47
        POP     AF                       ;            0437  F1
        ADD     A,B                      ;            0438  80

        ; Schaltjahr?
        AND     003h                     ;            0439  E603

        ; ja, 29 Tage: 29+1=2A (Obergrenze fuer CP-Befehl, binear!)
        LD      A,02Ah                   ;            043B  3E2A
        JR      Z,L0440                  ;  (   1):   043D  2801

        ; nein - nur 28 Tage
        DEC     A                        ;            043F  3D

L0440:
        ; gueltige Anzahl Tage fuer Februar in RAM-Tabelle abspeichern
        LD      (RAM_DAYS_FEBRUARY),A    ;            0440  326B80

        ; Jetzt indiziert ueber den Monat die Anzahl der Tage pro
        ; Monat aus der Tabelle holen....
        LD      A,(RAM_MONAT)            ;            0443  3A1980
        LD      E,A                      ;            0446  5F
        LD      D,000h                   ;            0447  1600
        LD      HL,RAM_DAYS_PER_MONTH    ;            0449  216980
        ADD     HL,DE                    ;            044C  19

        ;  ... und in B ablegen
        LD      B,(HL)                   ;            044D  46

        ; Kalendertag hochzaehlen
        LD      A,(RAM_TAG)              ;            044E  3A1880
        ADD     A,001h                   ;            0451  C601
        DAA                              ;            0453  27

        ; ablegen
        LD      (RAM_TAG),A              ;            0454  321880

        ; der Monat ist noch nicht zu Ende -> 'raus
        CP      B                        ;            0457  B8
        JR      C,L047A                  ;  (  32):   0458  3820

        LD      A,001h                   ;            045A  3E01
        LD      (RAM_TAG),A              ;            045C  321880

        ; Monat hochzaehlen
        LD      A,(RAM_MONAT)            ;            045F  3A1980
        ADD     A,001h                   ;            0462  C601
        DAA                              ;            0464  27
        LD      (RAM_MONAT),A            ;            0465  321980

        CP      013h                     ;            0468  FE13
        ; es ist das Jahr noch nicht zu Ende -> 'raus
        JR      C,L047A                  ;  (  14):   046A  380E

        LD      A,001h                   ;            046C  3E01
        LD      (RAM_MONAT),A            ;            046E  321980

        ; nachstes Jahr berechnen, der DAA-Befehl erledigt den Sprung
        ; von 99 auf 00
        LD      A,(RAM_JAHR)             ;            0471  3A1A80
        ADD     A,001h                   ;            0474  C601
        DAA                              ;            0476  27
        LD      (RAM_JAHR),A             ;            0477  321A80

; Fortsetzung von: 02F7h ...
; ... und Ende der ISR
L047A:  POP     HL                       ;            047A  E1
        POP     DE                       ;            047B  D1
        POP     BC                       ;            047C  C1
        POP     AF                       ;            047D  F1
        EI                               ;            047E  FB
        RETI                             ;            047F  ED4D

; Ende ISR


;*******************************************************************
; Funktion: ISR-Pointer Stundenschlag
;*******************************************************************
L0481:  RES     4,(IX+003h)              ;            0481  DDCB03A6
        RET                              ;            0485  C9

;*******************************************************************
; Funktion: ISR-Pointer Stundenschlag
;*******************************************************************
L0486:  LD      A,(IX+003h)              ;            0486  DD7E03
        RLA                              ;            0489  17
        CCF                              ;            048A  3F
        RRA                              ;            048B  1F
        SET     6,A                      ;            048C  CBF7
        LD      (IX+003h),A              ;            048E  DD7703
        BIT     7,A                      ;            0491  CB7F
        RET     NZ                       ;            0493  C0

;******************************************************************* 
; Funktion: ISR-Pointer Stundenschlag
;*******************************************************************
        DEC     (IX+001h)                ;            0494  DD3501
        RET     NZ                       ;            0497  C0

        LD      HL,L_NOTHING             ;            0498  21E704

L049B:  LD      (FPTR_SOUND),HL          ;            049B  222880
        RET                              ;            049E  C9

;*******************************************************************
; Funktion: ISR-Pointer Stundenschlag
;*******************************************************************
L049F:  DEC     (IX+002h)                ;            049F  DD3502
        LD      A,(IX+002h)              ;            04A2  DD7E02
        AND     003h                     ;            04A5  E603
        RRA                              ;            04A7  1F
        CCF                              ;            04A8  3F
        RRA                              ;            04A9  1F
        RRA                              ;            04AA  1F
        LD      B,A                      ;            04AB  47
        LD      A,(IX_003)               ;            04AC  3A2580
        AND     03Fh                     ;            04AF  E63F
        OR      B                        ;            04B1  B0
        LD      (IX_003),A               ;            04B2  322580
        LD      A,(IX_002)               ;            04B5  3A2480
        OR      A                        ;            04B8  B7
        RET     NZ                       ;            04B9  C0

;*******************************************************************
; Funktion: ISR-Pointer Stundenschlag
;*******************************************************************
        LD      HL,L_NOTHING             ;            04BA  21E704
        JR      L049B                    ;  ( -36):   04BD  18DC

;*******************************************************************
; Funktion: Konvertiert zweistellige BCD-Zahl zur Ausgabe im RAM
; Eingabe:  A=   Zahl (00h...99h)
;           HL=  Adresse der Ausgabe-Stelle (Zehner-Stelle)
; Ausgabe:  HL= HL_alt + 2
;*******************************************************************
PRINT_BCD:
        PUSH    AF                       ;            04BF  F5
        RRCA                             ;            04C0  0F
        RRCA                             ;            04C1  0F
        RRCA                             ;            04C2  0F
        RRCA                             ;            04C3  0F
        CALL    DISP_OUT_HALFBYTE        ;            04C4  CDC804

        POP     AF                       ;            04C7  F1

DISP_OUT_HALFBYTE:
        AND     00Fh                     ;            04C8  E60F
        BIT     2,(IX+003h)              ;            04CA  DDCB0356
        JR      Z,L04D7                  ;  (   7):   04CE  2807

        OR      A                        ;            04D0  B7
        JR      NZ,L04D7                 ;  (   4):   04D1  2004

        LD      (HL),000h                ;            04D3  3600
        JR      L04E2                    ;  (  11):   04D5  180B

L04D7:  PUSH    HL                       ;            04D7  E5
        LD      E,A                      ;            04D8  5F
        LD      D,000h                   ;            04D9  1600
        LD      HL,DATA_DEZ_TO_7SEG      ;            04DB  21E804
        ADD     HL,DE                    ;            04DE  19
        LD      A,(HL)                   ;            04DF  7E
        POP     HL                       ;            04E0  E1
        LD      (HL),A                   ;            04E1  77

L04E2:  INC     HL                       ;            04E2  23
        RES     2,(IX+003h)              ;            04E3  DDCB0396

; L_NOTHING koennte ueberall da stehen, wo ein RET steht ...
L_NOTHING:
        RET                              ;            04E7  C9

;***************************************************************************
; DATA
;***************************************************************************
DATA_DEZ_TO_7SEG:
; Umrechnung Dezimal -> 7-Segment
;           
;           '0'   '1'   '2'   '3'   '4'   '5'   '6'   '7'   '8'   '9'   '-'
        DB 03Fh, 006h, 05Bh, 04Fh, 066h, 06Dh, 07Ch, 007h, 07Fh, 067h, 040h

; Wem die (verstuemmelte) Darstellung der Ziffern "6" und "9" nicht gefaellt
; kann diese hier nehmen:
;       DB 03Fh, 006h, 05Bh, 04Fh, 066h, 06Dh, 07Dh, 007h, 07Fh, 06Fh, 040h


DATA_WEEKDAY_TO_7SEG:
; Umrechnung Wochentag -> 7-Segment
;           ' '   ' '
        DB 000h, 000h

;           'M'   'o'
        DB 037h, 05Ch

;          'd'    'i'
	DB 05Eh, 010h

;          'M'   'i'
        DB 037h, 010h

;          'd'   'o'
	DB 05Eh, 05Ch

;          'F'   'r'
	DB 071h, 050h

;          'S'   'A'
	DB 06Dh, 077h

;          'S'   'o'
	DB 06Dh, 05Ch

;          ' '

DATA_DAYS_PER_MONTH:
; Anzahl Tage pro Monat (fuer Software-Uhr)
;                Jan   Feb   Mrz   Apr   Mai   Jun   Jul   Aug   Sep
        DB 000h, 032h, 029h, 032h, 031h, 032h, 031h, 032h, 032h, 031h 

;       sechs Byte lange Luecke wegen HEX <-> DEZ Zahlensystem
        DB 000h, 000h, 000h, 000h, 000h, 000h

;          Oct   Nov   Dez
        DB 032h, 031h, 032h


;*******************************************************************
; Funktion: Jahrhundertkalender - berechnet aus dem empfangenen
;           Datum den Wochentag
;
; ------------------------------------------------------------------
; ACHTUNG: Diese Funktion funktioniert nicht fuer Jahre ab Jahr2000!
; Den Fehler habe ich leider noch nicht entdeckt (W.B.)  :-(
; ------------------------------------------------------------------
;
; Eingabe: H = Jahr  (00h...99h, 86..99 => 19xx, 00..85 => 20xx (?)
;          L = Monat (01h...12h)
;          A = Tag   (01h...31h)
; Ausgabe: A = Wochentag (1...7) = Mo...So
;*******************************************************************
KALENDER:

; Tag BCD->BIN wandeln und ablegen
        CALL    BCD_TO_BIN               ;            0516  CDF105
        LD      (KAL_DCF_TAG),A          ;            0519  327C80

; Monat BCD->BIN wandeln und ablegen
        LD      A,L                      ;            051C  7D
        CALL    BCD_TO_BIN               ;            051D  CDF105
        LD      (KAL_DCF_MONAT),A        ;            0520  327D80

; Jahr BCD->BIN wandeln und ablegen
        LD      A,H                      ;            0523  7C
        CALL    BCD_TO_BIN               ;            0524  CDF105
        LD      (KAL_DCF_JAHR),A         ;            0527  327E80

; Tag holen
        LD      A,(KAL_DCF_TAG)          ;            052A  3A7C80

; (Tag mod 7) berechnen
L052D:
        SUB     007h                     ;            052D  D607
        JR      Z,L0533                  ;  (   2):   052F  2802

L0531:
        JR      NC,L052D                 ;  (  -6):   0531  30FA

L0533:
; 6 dazuaddieren: 0...6 ablegen
        ADD     A,006h                   ;            0533  C606
        LD      (KAL_TAG_MOD),A          ;            0535  327F80

; Jahr holen und auf Schaltjahr testen
        LD      A,(KAL_DCF_JAHR)         ;            0538  3A7E80
        AND     003h                     ;            053B  E603
        LD      A,001h                   ;            053D  3E01
        JR      Z,L0542                  ;  (   1):   053F  2801
        XOR     A                        ;            0541  AF
L0542:

; Flag ablegen
;   A=1: Schaltjahr
;   A=0: kein Schaltjahr
        LD      (KAL_SCHALTJ),A          ;            0542  328080

; auf Jahrhundertwechsel testen (Jahr == 0)
        LD      A,(KAL_DCF_JAHR)         ;            0545  3A7E80
        OR      A                        ;            0548  B7
        JR      NZ,L055A                 ;  (  15):   0549  200F

; ============================================================================
; HIER STECKT EVENTUELL EIN FEHLER.
; Es wurde angenommen, dass der Jahrhundertwechsel kein Schaltjahr ist.
; Das stimmt auch - bis auf das Jahr-2000 - denn das ist doch eines.
; ============================================================================
        XOR     A                        ;            054B  AF
        LD      (KAL_SCHALTJ),A          ;            054C  328080

; Jetzt kommt irgendwas Komisches - wahrscheinlich ein Versuch, irgend was
; "patchfaehig" zu machen (?) 
; Jedenfalls ist das Schaltjahrflag einmal zerschossen und damit der Algorithmus
; falsch
        LD      A,013h                   ;            054F  3E13
        AND     003h                     ;            0551  E603
; springt immer!?
        JR      NZ,L055A                 ;  (   5):   0553  2005

        LD      A,001h                   ;            0555  3E01
        LD      (KAL_SCHALTJ),A          ;            0557  328080

L055A:
; kein Jahrhundertwechsel

; Zeiger auf Umrechnungstabelle setzen - Offset ist der Monat
        LD      A,(KAL_DCF_MONAT)        ;            055A  3A7D80
        LD      E,A                      ;            055D  5F
        LD      D,000h                   ;            055E  1600
        LD      HL,DATA_MONAT_OFFS       ;            0560  218606
        ADD     HL,DE                    ;            0563  19

; Verschiebung des Wochentages nach B holen
        LD      B,(HL)                   ;            0564  46

; War es ein Schaltjahr?
        LD      A,(KAL_SCHALTJ)          ;            0565  3A8080
        CP      001h                     ;            0568  FE01
; ja - dann inkrementiere B um 1, wenn Januar oder Februar ist
        CALL    Z,L0608                  ;            056A  CC0806

; auf 08081h wird nie wieder zugegriffen?
        LD      A,B                      ;            056D  78
        LD      (08081h),A               ;            056E  328180
        LD      E,A                      ;            0571  5F

; E = Tage-Verschiebung durch Monat im Jahr (?)

        LD      A,(KAL_TAG_MOD)          ;            0572  3A7F80
        LD      D,A                      ;            0575  57

; D = Kalendertag 0...6 
        LD      HL,DATA_START_OF_YEAR    ;            0576  212406

; Offset aus Tabelle holen
        CALL    L0614                    ;            0579  CD1406
        LD      (KAL_TAG_OFFS),A         ;            057C  328280

        LD      DE,0FFFFh                ;            057F  11FFFF
        LD      A,(KAL_DCF_JAHR)         ;            0582  3A7E80
        LD      B,A                      ;            0585  47
        INC     B                        ;            0586  04

L0587:  INC     D                        ;            0587  14
        INC     E                        ;            0588  1C
        LD      A,004h                   ;            0589  3E04
        CP      E                        ;            058B  BB
        JR      NZ,L0591                 ;  (   3):   058C  2003

        INC     D                        ;            058E  14
        LD      E,000h                   ;            058F  1E00

L0591:  LD      A,D                      ;            0591  7A
        CP      007h                     ;            0592  FE07
        JR      NZ,L0598                 ;  (   2):   0594  2002

        LD      D,000h                   ;            0596  1600

L0598:  CP      008h                     ;            0598  FE08
        JR      C,L059E                  ;  (   2):   059A  3802

        LD      D,001h                   ;            059C  1601

L059E:  DJNZ    L0587                    ;  ( -25):   059E  10E7

        LD      A,D                      ;            05A0  7A
        LD      (KAL_OFFSET2),A          ;            05A1  328380
        LD      A,E                      ;            05A4  7B
        LD      A,013h                   ;            05A5  3E13

L05A7:  SUB     004h                     ;            05A7  D604
        CP      00Fh                     ;            05A9  FE0F
        JR      NC,L05A7                 ;  (  -6):   05AB  30FA

        ADD     A,004h                   ;            05AD  C604
        CP      00Fh                     ;            05AF  FE0F
        CALL    Z,RET_DAY_4              ;            05B1  CCE205

        CP      010h                     ;            05B4  FE10
        CALL    Z,RET_DAY_5              ;            05B6  CCE505

        CP      011h                     ;            05B9  FE11
        CALL    Z,RET_DAY_0              ;            05BB  CCE805

        CP      012h                     ;            05BE  FE12
        CALL    Z,RET_DAY_2              ;            05C0  CCEB05

        LD      E,A                      ;            05C3  5F
        LD      A,(KAL_OFFSET2)          ;            05C4  3A8380
        LD      D,A                      ;            05C7  57
        LD      HL,DATA_0655             ;            05C8  215506
        CALL    L0614                    ;            05CB  CD1406

        LD      C,A                      ;            05CE  4F
        LD      A,(KAL_TAG_OFFS)         ;            05CF  3A8280
        ADD     A,C                      ;            05D2  81

L05D3:  SUB     007h                     ;            05D3  D607
        JR      C,L05DB                  ;  (   4):   05D5  3804

        CP      001h                     ;            05D7  FE01
        JR      NC,L05D3                 ;  (  -8):   05D9  30F8

L05DB:  ADD     A,006h                   ;            05DB  C606
        OR      A                        ;            05DD  B7
        CALL    Z,RET_DAY_7              ;            05DE  CCEE05

        RET                              ;            05E1  C9


RET_DAY_4:
        LD      A,004h                   ;            05E2  3E04
        RET                              ;            05E4  C9


RET_DAY_5:
        LD      A,005h                   ;            05E5  3E05
        RET                              ;            05E7  C9


RET_DAY_0:
        LD      A,000h                   ;            05E8  3E00
        RET                              ;            05EA  C9


RET_DAY_2:
        LD      A,002h                   ;            05EB  3E02
        RET                              ;            05ED  C9


RET_DAY_7:
        LD      A,007h                   ;            05EE  3E07
        RET                              ;            05F0  C9


;*******************************************************************
; Funktion: Konvertiert zweistellige BCD-Zahl in eine Binaer-Zahl
; (BCD-Eingabe in "normale" acht-Bit-Zahl umwandeln)
; Eingabe: A = 2-stellig BCD
; Ausgabe: A = 8-Bit Binearzahl
;*******************************************************************
BCD_TO_BIN:
        PUSH    AF                       ;            05F1  F5
        RRCA                             ;            05F2  0F
        RRCA                             ;            05F3  0F
        RRCA                             ;            05F4  0F
        RRCA                             ;            05F5  0F
        AND     00Fh ; ueberfluessig!    ;            05F6  E60F

        LD      C,00Ah                   ;            05F8  0E0A
        LD      B,A                      ;            05FA  47

        XOR     A                        ;            05FB  AF
        CP      B                        ;            05FC  B8
        JR      Z,L0602                  ;  (   3):   05FD  2803

L05FF:  ADD     A,C                      ;            05FF  81
        DJNZ    L05FF                    ;  (  -3):   0600  10FD

L0602:  LD      C,A                      ;            0602  4F
        POP     AF                       ;            0603  F1
        AND     00Fh                     ;            0604  E60F
        ADD     A,C                      ;            0606  81
        RET                              ;            0607  C9


;*******************************************************************
; Funktion: Inkrementiert B um 1, wenn Januar oder Februar ist
;*******************************************************************
L0608:  LD      A,(KAL_DCF_MONAT)        ;            0608  3A7D80
        CP      001h                     ;            060B  FE01
        JR      Z,L0612                  ;  (   3):   060D  2803

        CP      002h                     ;            060F  FE02
        RET     NZ                       ;            0611  C0


L0612:  INC     B                        ;            0612  04
        RET                              ;            0613  C9


;*******************************************************************
; Funktion:
; Eingabe: HL = &DATA_START_OF_YEAR
;          D  = Kalendertag 0...6 
;          E  = Tage-Verschiebung durch Monat im Jahr
; Ausgabe: A  = Offset aus Tabelle
;*******************************************************************
L0614:
        LD      B,D                      ;            0614  42
        LD      D,000h                   ;            0615  1600
        ADD     HL,DE                    ;            0617  19
        LD      DE,00007h                ;            0618  110700
        LD      A,B                      ;            061B  78
        OR      A                        ;            061C  B7
        JR      Z,L0622                  ;  (   3):   061D  2803

L061F:  ADD     HL,DE                    ;            061F  19
        DJNZ    L061F                    ;  (  -3):   0620  10FD

L0622:  LD      A,(HL)                   ;            0622  7E
        RET                              ;            0623  C9

;*******************************************************************
; Tabelle zur Berechnung des Wochentags im Jahr - Offsettabelle
DATA_START_OF_YEAR:
;*******************************************************************
        DB 006h, 005h, 002h, 001h, 007h, 003h, 004h, 007h, 006h, 003h 
        DB 002h, 001h, 004h, 005h, 001h, 007h, 004h, 003h, 002h, 005h
        DB 006h, 002h, 001h, 005h, 004h, 003h, 006h, 007h, 003h, 002h
        DB 006h, 005h, 004h, 007h, 001h, 004h, 003h, 007h, 006h, 005h
        DB 001h, 002h, 005h, 004h, 001h, 007h, 006h, 002h, 003h

DATA_0655:
        DB 007h
        DB 006h, 005h, 004h, 003h, 002h, 001h, 001h, 007h, 006h, 005h
        DB 004h, 003h, 002h, 002h, 001h, 007h, 006h, 005h, 004h, 003h
        DB 003h, 002h, 001h, 007h, 006h, 005h, 004h, 004h, 003h, 002h
        DB 001h, 007h, 006h, 005h, 005h, 004h, 003h, 002h, 001h, 007h
        DB 006h, 006h, 005h, 004h, 003h, 002h, 001h, 007h

DATA_MONAT_OFFS:
; Tabelle enthaelt die Verschiebung des Wochentages pro Monat im Jahr,
; bezogen auf den 1.Januar (invers)

;       Dummy (Monat beginnt bei 1)
        DB 000h

;           Jan   Feb   Mrz   Apr   Mai   Jun   Jul   Aug   Sep
        DB 000h, 002h, 002h, 001h, 004h, 005h, 001h, 003h, 006h

;           Okt   Nov   Dez      
        DB 000h, 002h, 006h

        DB 020h, 020h

; CopyRight-Vermerk

        DB "DIESES PROGRAMM WURDE VON STEFFEN LEHMANN, "
        DB "1142 BERLIN, BRODOWINER RING 30 "
        DB "GESCHRIEBEN. DIE WEITERGABE AN DRITTE IST ERLAUBT, "
        DB "WENN DER WEITERGEBENDE DIE UHRHEBERSCHAFT NICHT VERAENDERT "
        DB "ODER VERSCHLEIERT. "
        DB "(BERLIN, FEBRUAR 1985) "

; PATCH-Vermerk
        DB "PATCH#1: MACHT TEST AUF BERECHNETEN/EMPFANGENEN WOCHENTAG "
        DB "UNWIRKSAM WEGEN FEHLER IN KALENDERROUTINE. "
        DB "(W.B. - BERLIN JANUAR 2000) "